define function extract_number% (a$,start$,stop$)
remark extracts a number from string a$ which is between start$ and stop$,
remark both of which must  be unique
remark returns the number or -1 if error
local startlen%,temp%,lp%,res%,b$
  if a$="" or start$="" or stop$="":return -1
  temp%=start$ instr a$
  if not temp%:return -1
  startlen%=len (start$)
  if temp%+startlen%>len(a$)-1:return -1
  b$=a$(temp%+startlen% to)
  temp%=stop$ instr b$
  if temp%<2:return -1
  b$=b$(1 to temp%-1)
  if b$="":return -1
  for lp%=1 to len(b$)
    if not (b$(lp%) instr "0123456789"):return -1
  end for lp%
  res%=b$			: rem coukd return b$ directly!
  return res%
end define extract_number%
:
define function extract_one_number% (a$,start$)
remark extracts a number from string a$ which is between start$ and stop$,
remark both of which must  be unique
remark returns the number (0...9 and 10..36 for a...z or -1 if error
local startlen%,temp%,lp%,b$
  if a$="" or start$="":return -1
  temp%=start$ instr a$
  if not temp%:return -1
  startlen%=len (start$)
  if temp%+startlen%>len(a$)-1:return -1
  b$=a$(temp%+startlen%)
  if b$="":return -1
  temp%=code(b$)
  select on temp%
    =48 to 57 : temp%= temp%-48
    =97 to 122 : temp%=temp%-87
    =remainder : temp%=-1
  end select
  return temp%
end define extract_one_number%
:
